;********************************* 
;* Title : libRequesterPerso.pbi
;* Permet de crer ses propres MessageRequester avec la Police qui va bien.
;* Author : GeoTrouvpatou aka El Konkonbre Masqued 
;* Date : 12/06/2011 
;* Compatibility 
;* Windows x86 [?] | Windows x64 [Ok] 
;* Linux x86 [?] | Linux x64 [Ok] 
;* MacOs PPC [?] | MacOs intel [?] 
;* Unicode [?] 
;* Demo version [Ok] 
;********************************* 
EnableExplicit

CompilerSelect #PB_Compiler_OS 
      CompilerCase #PB_OS_Windows
            #EOL$ = #CRLF$ : #SeparatorDir = "\"
            If InitSound() = 0
                  MessageRequester("Error", "Can't open DirectX 7 or no sound card is available",  0)
                  End
            EndIf
            
      CompilerCase #PB_OS_Linux   : #EOL$ = #LF$ : #SeparatorDir = "/"
      CompilerCase #PB_OS_MacOS   : #EOL$ = #CR$ 
CompilerEndSelect


Enumeration #PB_Compiler_EnumerationValue
      ; Permet d'avoir un ButtonGadget avec un Id diffrent
      #RP_Bouton_Yes 
      #RP_Bouton_No 
      #RP_Bouton_Cancel 
      #RP_Bouton_Ok

      #MRP_iconeExclamation
      #MRP_iconeInformation
      #MRP_iconeQuestion
      #MRP_iconeError
      #MRP_iconeAucune
      
      #MRP_Raccourci_Escape
EndEnumeration


#MRP_Yes = 6      ; Le bouton 'Oui' a t press
#MRP_No = 7       ; Le bouton 'Non' a t press
#MRP_Cancel = 2  ; Le bouton 'Annuler' a t press
#MRP_Ok = 1       ; Le bouton 'Ok' a t press

; -------------------------------------------------------------------------------------------
;- Image et son Plugins
; -------------------------------------------------------------------------------------------
UsePNGImageDecoder()
UseOGGSoundDecoder()


; -------------------------------------------------------------------------------------------
;- Declares
; -------------------------------------------------------------------------------------------
Declare.i MessageRequesterPerso(width.i, height.i, titreFenetre$, List ListMessage$(), policeNom$, policeTaille.b, hauteurDeLigne.b, modeDebug.b = 0, iconeAvertissement.i = #MRP_iconeAucune, texteDesBoutons$ = "OK", flag.i = #PB_Window_TitleBar | #PB_Window_ScreenCentered)
Declare$ NettoyerTexte(chaine$)


; -------------------------------------------------------------------------------------------
;- Images et sons incrusts en ressources.
; -------------------------------------------------------------------------------------------
DataSection
      iconeAucune:
      IncludeBinary "images"+ #SeparatorDir +"iconeAucune.png"
      iconeError:
      IncludeBinary "images"+ #SeparatorDir +"iconeError.png"
      iconeExclamation:
      IncludeBinary "images"+ #SeparatorDir +"iconeExclamation.png"
      iconeInformation:
      IncludeBinary "images"+ #SeparatorDir +"iconeInformation.png"
      iconeQuestion:
      IncludeBinary "images"+ #SeparatorDir +"iconeQuestion.png"
      imageHelp:
      IncludeBinary "images"+ #SeparatorDir +"help.png"
      
      CompilerIf #PB_Compiler_OS = #PB_OS_Windows
            sonError:
            IncludeBinary "sons"+ #SeparatorDir +"sonError.ogg"
            sonErrorFin:
            sonExclamation:
            IncludeBinary "sons"+ #SeparatorDir +"sonExclamation.ogg"
            sonExclamationFin:
            sonInformation:
            IncludeBinary "sons"+ #SeparatorDir +"sonInformation.ogg"
            sonInformationFin:
            sonQuestion:
            IncludeBinary "sons"+ #SeparatorDir +"sonQuestion.ogg"
            sonQuestionFin:
      CompilerEndIf
EndDataSection


; -------------------------------------------------------------------------------------------
;- Procedures
; -------------------------------------------------------------------------------------------
Procedure.i MessageRequesterPerso(width.i, height.i, titreFenetre$, List ListMessage$(), policeNom$, policeTaille.b, hauteurDeLigne.b, modeDebug.b = 0, iconeAvertissement.i = #MRP_iconeAucune, texteDesBoutons$ = "OK", flag.i = #PB_Window_TitleBar | #PB_Window_ScreenCentered)
      Protected window.i
      
      Protected.i x = 100, y = 100 ; Valeurs par dfaut de l'OpenWindow
      
      ; Ajout Image
      Protected.b imageLargeur, imageHauteur
      Protected iconeImageId.i
      Protected.b iconeAvertissementExiste ; Permet de dcaler le texte  partir de la gauche en fonction de si l'image existe ou pas
      Protected catchSoundId.i ; Son en fonction de l'image
      
      ; Ajout Message
      Protected x_TextGadget.i = 0, y_TextGadget.i = 10, width_TextGadget.i = 0 ;, idTextGadget.i = 600
      Protected fontTypeId.i
      Protected textGadgetId.i
      
      ; Ajout des boutons
      Protected nbBoutons.i, i.i, textesSurLeBouton$;, idConcat$;, valeur.i;, retour.i
      
      Protected x_ButtonGadget.i
      Protected width_ButtonGadget.b = 100
      Protected height_ButtonGadget.b = 24 
      
      Protected idButtonGadget.i
      Protected buttonFontTypeId.i 
      
      
      Protected evenement.i, quit.i ; Sert  la loop
      
      Protected retourProcedure.b      
      
      
      ;- [1] Ouverture fentre.
      window = OpenWindow(#PB_Any, x, y, width, height, titreFenetre$, flag)
      
      AddKeyboardShortcut(window, #PB_Shortcut_Escape, #MRP_Raccourci_Escape)
      StickyWindow(window, 1)
      
      ; Debug ">>>>>>>> #RP_Window : "+ Str(window)
      
      ;- [2] Icone d'avertissement.
      ; S'il y a bien une icone d'avertissement.
      If iconeAvertissement <> #MRP_iconeAucune
            
            If iconeAvertissement = #MRP_iconeExclamation
                  iconeImageId = CatchImage(#PB_Any, ?iconeExclamation)
                  
                  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
                        catchSoundId = CatchSound(#PB_Any, ?sonExclamation, ?sonExclamationFin - ?sonExclamation)
                  CompilerEndIf
                  
            EndIf            
            
            If iconeAvertissement = #MRP_iconeInformation
                  iconeImageId = CatchImage(#PB_Any, ?iconeInformation)
                  
                  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
                        catchSoundId = CatchSound(#PB_Any, ?sonInformation, ?sonInformationFin - ?sonInformation)
                  CompilerEndIf
                  
            EndIf
            
            If iconeAvertissement = #MRP_iconeQuestion
                  iconeImageId = CatchImage(#PB_Any, ?iconeQuestion)
                  
                  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
                        catchSoundId = CatchSound(#PB_Any, ?sonQuestion, ?sonQuestionFin - ?sonQuestion)
                  CompilerEndIf
                  
            EndIf
            
            If iconeAvertissement = #MRP_iconeError
                  iconeImageId = CatchImage(#PB_Any, ?iconeError)
                  
                  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
                        catchSoundId = CatchSound(#PB_Any, ?sonError, ?sonErrorFin - ?sonError)
                  CompilerEndIf
                  
            EndIf
            
            
            ; Si l'iconeAvertissement existe bien.
            If iconeImageId
                  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
                        ; A l'ouverture de la fentre le son est jou.
                        PlaySound(catchSoundId)
                  CompilerEndIf
                  
                  
                  ; On determine la h et l de l'image pour additionner ou soustraire tout a dans la 
                  ; pour dterminer la largeur max du TextGadget
                  imageLargeur = ImageWidth(iconeImageId)
                  imageHauteur = ImageHeight(iconeImageId)
                  
                  ImageGadget(#PB_Any, 10, 10, imageLargeur, imageHauteur, ImageID(iconeImageId))
                  
                  iconeAvertissementExiste = #True ; Permet de prciser que l'on a mis une image pour afficher : Image + Texte
            Else
                  MessageRequester("Erreur", "Impossible de charger l'image")
                  ;End
                  
            EndIf
            
      Else
            ; S'il n'y a pas d'iconeAvertissement
            iconeAvertissementExiste = #False ; Permet de prciser que l'on n'a pas mis une image pour afficher : Texte uniquement.
      EndIf 
      
      
      
      ;- [3] Afichage du message.
      ; Si image
      If iconeAvertissementExiste
            ; On calcul la largeur maxi que peut prendre un TextGadget en fonction de la largeur de l' OpenWindow
            ; 20 c'est 10px du dbut de la fentre  l'image et 10px aprs l'image et c'est aprs que l'on affichera le texte.
            x_TextGadget = x_TextGadget + imageLargeur + 20
            ; Largeur du label = With de OpenWindows 
            ; width = *fenetre\Width - 52 - 10 - 10 - 10 - 10
            width_TextGadget = width - imageLargeur - 10 - 10 - 10
            
      Else
            x_TextGadget = x_TextGadget + 10
            ; 10 du dbut et de la fin
            width_TextGadget = width - 10 - 10
            
      EndIf 
      
      ;- [3a] On charge la police pour le message.
      fontTypeId = LoadFont(#PB_Any, policeNom$, policeTaille)
      
      ;- [3b] Afichage du message en fonction de la police/taille et du mode Debugage.
      If modeDebug
            ForEach ListMessage$()
                  textGadgetId = TextGadget(#PB_Any, x_TextGadget, y_TextGadget, width_TextGadget, hauteurDeLigne, ListMessage$(), #PB_Text_Border)
                  SetGadgetFont(textGadgetId, FontID(fontTypeId)) 
                  ; Debug "textGadgetId : "+ Str(textGadgetId)
                  
                  y_TextGadget + hauteurDeLigne
            Next
            
      Else
            ForEach ListMessage$()
                  textGadgetId = TextGadget(#PB_Any, x_TextGadget, y_TextGadget, width_TextGadget, hauteurDeLigne, ListMessage$())
                  SetGadgetFont(textGadgetId, FontID(fontTypeId)) 
                  ;Debug "textGadgetId : "+ Str(textGadgetId)
                  
                  y_TextGadget + hauteurDeLigne
            Next
            
      EndIf     
      
      
      
      
      
      ;- [4] Ajout des boutons
      ; OK
      ; Oui|Non
      ; Oui|Non|Annuler
      ; Debug ">>>>>>>>>>>>>>>> texteDesBoutons$ : "+ texteDesBoutons$
      
      ; Ex : Oui|Non donc 1 sparateur gale 2 boutons (D'o le +1  la fin)
      nbBoutons = CountString(texteDesBoutons$, "|") + 1
      ;Debug "nbBoutons "+ Str(nbBoutons)
      
      
      ; Permet de centrer les 1,2 ou 3 boutons quelque soit la largeur de l'OpenWindow
      x_ButtonGadget = (width - (width_ButtonGadget * nbBoutons + 5)) / 2
      
      ; Les boutons
      For i = 1 To nbBoutons
            textesSurLeBouton$ = StringField(texteDesBoutons$, i, "|")
            
            If textesSurLeBouton$ = "Oui"
                  idButtonGadget = #RP_Bouton_Yes
                  ; Debug "#Const_Oui = "+ Str(idButtonGadget)
                  
            ElseIf textesSurLeBouton$ = "Non"
                  idButtonGadget = #RP_Bouton_No
                  ; Debug "#Const_Non = "+ Str(idButtonGadget)
                  
            ElseIf textesSurLeBouton$ = "Annuler"
                  idButtonGadget = #RP_Bouton_Cancel
                  ; Debug "#Const_Annuler = "+ Str(idButtonGadget)
                  
            ElseIf textesSurLeBouton$ = "OK"
                  idButtonGadget = #RP_Bouton_Ok
                  ; Debug "#Const_Ok = "+ Str(idButtonGadget)
                  
            EndIf
            
            
            ;- [5] On charge la police.
            buttonFontTypeId = LoadFont(#PB_Any, policeNom$, 10)
            
            ; On Affiche le/les bouton(s)
            ; -40 pour remonter un peu le bouton par rapport au bas de la fentre.
            ButtonGadget(idButtonGadget, x_ButtonGadget,  height - 40, width_ButtonGadget, height_ButtonGadget, textesSurLeBouton$)
            SetGadgetFont(idButtonGadget, FontID(buttonFontTypeId))
            
            ; +5 ecart entre 2 boutons.
            x_ButtonGadget = x_ButtonGadget + width_ButtonGadget + 5
            
      Next i
      
      
      ;- Ma loop
      Repeat
            evenement = WaitWindowEvent()
            
            ;->> Evnements Menu
            If evenement = #PB_Event_Menu
                  Select EventMenu()
                              
                        Case #MRP_Raccourci_Escape
                              ; Si les btn Oui|Non sont affichs la croix n'est pas prsente.
                              ; Donc on ne doit pas pouvoir chapper
                              If texteDesBoutons$ <> "Oui|Non"
                                    
                                    If texteDesBoutons$ = "OK"
                                          retourProcedure = #MRP_Ok
                                    EndIf 
                                    
                                    If texteDesBoutons$ = "Oui|Non|Annuler"
                                          retourProcedure = #MRP_Cancel
                                    EndIf  
                                    
                                    ; On ferme la fenetre mais il ne faut surtout pas oublier de quitter la boucle
                                    CloseWindow(window)
                                    quit = 1
                                    
                              EndIf 
                              
                  EndSelect
            EndIf
            
            
            
            ;/ Evnements Window
            If evenement = #PB_Event_CloseWindow
                  Select EventWindow() 
                              
                              ; Permet de fermer la fenetre en cliquant sur la croix.  
                        Case window
                              If texteDesBoutons$ = "OK"
                                    retourProcedure = #MRP_Ok
                              EndIf 
                              
                              If texteDesBoutons$ = "Oui|Non|Annuler"
                                    retourProcedure = #MRP_Cancel
                              EndIf  
                              
                              CloseWindow(window)
                              quit = 1
                              
                  EndSelect 
                  
            EndIf
            
            
            
            ;/ Evnements Boutons (Gadget en gnral
            If evenement =  #PB_Event_Gadget
                  Select EventGadget()   
                              
                        Case #RP_Bouton_Yes 
                              retourProcedure = #MRP_Yes
                              CloseWindow(window)
                              quit = 1
                              
                        Case #RP_Bouton_No    
                              retourProcedure = #MRP_No
                              CloseWindow(window)
                              quit = 1
                              
                        Case #RP_Bouton_Cancel    
                              retourProcedure = #MRP_Cancel
                              CloseWindow(window)
                              quit = 1
                              
                        Case #RP_Bouton_Ok    
                              retourProcedure = #MRP_Ok
                              CloseWindow(window)
                              quit = 1  
                              
                  EndSelect
                  
            EndIf
            
      Until quit = 1
      
      ProcedureReturn retourProcedure
EndProcedure

; Sert pour mettre une variable dans un message
; Ex : nomOS$ = "Windows"
; Texte du MRPerso : Le nom de mon OS est {{nomOS$}}, et j'en suis bien content.
Procedure$ NettoyerTexte(chaine$)
      chaine$ = ReplaceString(chaine$, Chr(34), Chr(34) +"+ Chr(34) +"+ Chr(34))
      chaine$ = ReplaceString(chaine$, "{{", Chr(34) + Chr(43)) 
      chaine$ = ReplaceString(chaine$, "}}", Chr(43)+ Chr(34)) 
      ProcedureReturn chaine$
EndProcedure
; IDE Options = PureBasic 4.60 RC 1 (Windows - x64)
; CursorPosition = 17
; Folding = -
; Markers = 44,321
; EnableXP